/* init.c */
/* Last modified: June 27, 2007 */


/* Initialize useful bitboards */
void initBitBoards(sOthers *others)
{
  BB Temp;
  ui sq, i, j;
  int k;
  ui r, c;       /* row, column */

  ASSERT(others != NULL);

  for (i = 0; i <= 7; i++)
    {
      others->Row[i] = OneMask[i*8] | OneMask[i*8+1] | OneMask[i*8+2] | 
	OneMask[i*8+3] | OneMask[i*8+4] | OneMask[i*8+5] | 
	OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8] = OneMask[i*8+1] | OneMask[i*8+2] | 
	OneMask[i*8+3] | OneMask[i*8+4] | OneMask[i*8+5] | 
	OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8+1] = OneMask[i*8+2] | 
	OneMask[i*8+3] | OneMask[i*8+4] | OneMask[i*8+5] | 
	OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8+2] = OneMask[i*8+3] | OneMask[i*8+4] | OneMask[i*8+5] |
	OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8+3] = OneMask[i*8+4] | OneMask[i*8+5] | 
	OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8+4] = OneMask[i*8+5] | OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8+5] = OneMask[i*8+6] | OneMask[i*8+7];
      others->Up1Of[i*8+6] = OneMask[i*8+7];
      others->Up1Of[i*8+7] = (BB) 0;
      others->Down1Of[i*8] = others->Row[i] & ~others->Up1Of[i*8] & 
	NilMask[i*8];
      others->Down1Of[i*8+1] = others->Row[i] & ~others->Up1Of[i*8+1] & 
	NilMask[i*8+1];
      others->Down1Of[i*8+2] = others->Row[i] & ~others->Up1Of[i*8+2] & 
	NilMask[i*8+2];
      others->Down1Of[i*8+3] = others->Row[i] & ~others->Up1Of[i*8+3] & 
	NilMask[i*8+3];
      others->Down1Of[i*8+4] = others->Row[i] & ~others->Up1Of[i*8+4] & 
	NilMask[i*8+4];
      others->Down1Of[i*8+5] = others->Row[i] & ~others->Up1Of[i*8+5] & 
	NilMask[i*8+5];
      others->Down1Of[i*8+6] = others->Row[i] & ~others->Up1Of[i*8+6] & 
	NilMask[i*8+6];
      others->Down1Of[i*8+7] = others->Row[i] & ~others->Up1Of[i*8+7] & 
	NilMask[i*8+7];
    }

  for (i = 0; i <= 7; i++)
    others->Column[i] = OneMask[i] | OneMask[i+8] | OneMask[i+16] | 
      OneMask[i+24] | OneMask[i+32] | OneMask[i+40] | OneMask[i+48] | 
      OneMask[i+56];

  others->Edge = others->Row[0] | others->Row[7] |
    others->Column[0] | others->Column[7];
  others->InnerEdge = others->Row[1] | others->Row[6] |
    others->Column[1] | others->Column[6];

  for (sq = A1; sq <= H8; sq++)
    {
      others->Up8Of[sq] = others->Down8Of[sq] = others->SideOf[sq] = 
	others->Up8SideOf[sq] = others->Down8SideOf[sq] = (BB) 0;
      if (sq+8 <= H8) for (k = sq+8; k <= H8; k += 8) others->Up8Of[sq] |= OneMask[k];
      if (sq-8 >= A1) for (k = sq-8; k >= A1; k -= 8) others->Down8Of[sq] |= OneMask[k];
      if (column(sq) < 7)
	{
	  others->SideOf[sq] |= OneMask[sq+1];
	  if (sq+9 <= H8) for (k = sq+9; k <= H8; k += 8) others->Up8SideOf[sq] |= OneMask[k];
	  if (sq-7 >= A1) for (k = sq-7; k >= A1; k -= 8) others->Down8SideOf[sq] |= OneMask[k];
	}
      if (column(sq) > 0)
	{
	  others->SideOf[sq] |= OneMask[sq-1];
	  if (sq+7 <= H8) for (k = sq+7; k <= H8; k += 8) others->Up8SideOf[sq] |= OneMask[k];
	  if (sq-9 >= A1) for (k = sq-9; k >= A1; k -= 8) others->Down8SideOf[sq] |= OneMask[k];
	}
    }

  others->QueenSide = others->Column[0] | others->Column[1] | others->Column[2] | others->Column[3];
  others->FarQueenSide = others->Column[0] | others->Column[1] | others->Column[2];
  others->KingSide = others->Column[4] | others->Column[5] | others->Column[6] | others->Column[7];
  others->FarKingSide = others->Column[5] | others->Column[6] | others->Column[7];

  others->Dark = 
    OneMask[A1] | OneMask[C1] | OneMask[E1] | OneMask[G1] | 
    OneMask[B2] | OneMask[D2] | OneMask[F2] | OneMask[H2] | 
    OneMask[A3] | OneMask[C3] | OneMask[E3] | OneMask[G3] | 
    OneMask[B4] | OneMask[D4] | OneMask[F4] | OneMask[H4] | 
    OneMask[A5] | OneMask[C5] | OneMask[E5] | OneMask[G5] | 
    OneMask[B6] | OneMask[D6] | OneMask[F6] | OneMask[H6] | 
    OneMask[A7] | OneMask[C7] | OneMask[E7] | OneMask[G7] | 
    OneMask[B8] | OneMask[D8] | OneMask[F8] | OneMask[H8];
  others->Light = 
    OneMask[B1] | OneMask[D1] | OneMask[F1] | OneMask[H1] | 
    OneMask[A2] | OneMask[C2] | OneMask[E2] | OneMask[G2] | 
    OneMask[B3] | OneMask[D3] | OneMask[F3] | OneMask[H3] | 
    OneMask[A4] | OneMask[C4] | OneMask[E4] | OneMask[G4] | 
    OneMask[B5] | OneMask[D5] | OneMask[F5] | OneMask[H5] | 
    OneMask[A6] | OneMask[C6] | OneMask[E6] | OneMask[G6] | 
    OneMask[B7] | OneMask[D7] | OneMask[F7] | OneMask[H7] | 
    OneMask[A8] | OneMask[C8] | OneMask[E8] | OneMask[G8];

  /* Rows above and below specific squares */
  for (sq = A1; sq <= H7; sq++) others->OneUp[sq] = others->Row[row(sq)+1];
  for (sq = A1; sq <= H6; sq++) others->TwoUp[sq] = others->Row[row(sq)+2];
  for (sq = H8; sq >= A2; sq--) others->OneDown[sq] = others->Row[row(sq)-1];
  for (sq = H8; sq >= A3; sq--) others->TwoDown[sq] = others->Row[row(sq)-2];

  /* Columns on either sides of specific squares */
  for (sq = A1; sq <= H8; sq++)
    {
      c = column(sq);
      if (c > 0) others->OneSide[sq] = others->Column[c-1];
      if (c < 7) others->OneSide[sq] |= others->Column[c+1];
    }

  for (sq = A1; sq <= H8; sq++)
    {
      c = column(sq);
      if (c > 1) others->TwoSide[sq] = others->Column[c-2];
      if (c < 6) others->TwoSide[sq] |= others->Column[c+2];
    }

  /* White pawn captures */
  for (sq = A1; sq <= H7; sq++)
    {
      c = column(sq);
      others->WPCaptures[sq] = others->OneUp[sq] & others->OneSide[c];
    }

  /* Black pawn captures */
  for (sq = H8; sq >= A2; sq--)
    {
      c = column(sq);
      others->BPCaptures[sq] = others->OneDown[sq] & others->OneSide[c];
    }

  /* Knight moves */
  for (sq = A1; sq <= H8; sq++)
    {
      others->NMoves[sq] = 
	(others->OneUp[sq] | others->OneDown[sq]) & others->TwoSide[sq];
      others->NMoves[sq] |= 
	(others->TwoUp[sq] | others->TwoDown[sq]) & others->OneSide[sq];
    }

  /* Bishop moves */
  for (sq = A1; sq <= H8; sq++)
    {
      r = row(sq);
      c = column(sq);
      others->BMoves[sq] = (BB) 0;

      /* plus 7 dkrection */
      if (sq+7 <= H8) for (k = sq+7; k <= H8 && row(k) > r && column(k) < c; k += 7)
	others->Up7Of[sq] |= OneMask[k];

      /* plus 9 dkrection */
      if (sq+9 <= H8) for (k = sq+9; k <= H8 && row(k) > r && column(k) > c; k += 9)
	others->Up9Of[sq] |= OneMask[k];

      /* mknus 7 dkrection */
      if (sq-7 >= A1) for (k = sq-7; k >= A1 && row(k) < r && column(k) > c; k -= 7)
	others->Down7Of[sq] |= OneMask[k];

      /* mknus 9 dkrection */
      if (sq-9 >= A1) for (k = sq-9; k >= A1 && row(k) < r && column(k) < c; k -= 9)
	others->Down9Of[sq] |= OneMask[k];
      
      others->BMoves[sq] = others->Up7Of[sq] | others->Up9Of[sq] | 
	others->Down7Of[sq] | others->Down9Of[sq]; 
    }

  /* King moves and neighborhood */
  for (sq = A1; sq <= H8; sq++)
    for (i = A1; i <= H8; i++)
      {
	if (distance(sq,i) == 1) others->KMoves[sq] |= OneMask[i];
	if (distance(sq,i) < 3) others->KHood[sq] |= OneMask[i];
      }

  /* direction from i to j */
  for (i = A1; i <= H8; i++)
    for (j = A1; j <= H8; j++)
      others->direction[i][j] = 0;
  for (i = A1; i <= H8; i++)
    {
      /* up 1 direction */
      Temp = others->Up1Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = 1;
	  Temp &= NilMask[j];
	}

      /* up 7 direction */
      Temp = others->Up7Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = 7;
	  Temp &= NilMask[j];
	}

      /* up 8 direction */
      Temp = others->Up8Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = 8;
	  Temp &= NilMask[j];
	}

      /* up 9 direction */
      Temp = others->Up9Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = 9;
	  Temp &= NilMask[j];
	}
      /* down 1 direction */
      Temp = others->Down1Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = -1;
	  Temp &= NilMask[j];
	}

      /* down 7 direction */
      Temp = others->Down7Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = -7;
	  Temp &= NilMask[j];
	}

      /* down 8 direction */
      Temp = others->Down8Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = -8;
	  Temp &= NilMask[j];
	}

      /* down 9 direction */
      Temp = others->Down9Of[i];
      while (Temp)
	{
	  j = firstOne(Temp);
	  others->direction[i][j] = -9;
	  Temp &= NilMask[j];
	}
    }
}


/* Initialize hash keys */
void initKeys(sOthers *others)
{
  ui i;

  ASSERT(others != NULL);

  /* without initial seed, random64() produces repeated keys */
  setRandomSeed(11141957);
  for (i = A1; i <= H8; i++)
    {
      others->wPKey[i] = random64();
      others->wNKey[i] = random64();
      others->wBKey[i] = random64();
      others->wRKey[i] = random64();
      others->wQKey[i] = random64();
      others->wKKey[i] = random64();
      others->bPKey[i] = random64();
      others->bNKey[i] = random64();
      others->bBKey[i] = random64();
      others->bRKey[i] = random64();
      others->bQKey[i] = random64();
      others->bKKey[i] = random64();
      others->ePKey[i] = random64();
    }

  for (i = 0; i < 4; i++)
    {
      others->wCanCastleKey[i] = random64();
      others->bCanCastleKey[i] = random64();
    }
}


/* Initialize hash tables */
void clearHash(sHash **hash, sPos *pos)
{
  memset(hash[white], 0, sizeof(struct HashTable) * (pos->hashSize+1));
  memset(hash[black], 0, sizeof(struct HashTable) * (pos->hashSize+1));
}


/* Initialize the hash keys and various bitboards */
void finalizeInit(ui* piece, sPos *pos, sPlyData *thisPlyData,
		  sOthers *others)
{
  ui sq;
  BB *pWAttacker = (BB *) thisPlyData->wAttacker;
  BB *pBAttacker = (BB *) thisPlyData->bAttacker;

  ASSERT(pos != NULL);
  ASSERT(thisPlyData != NULL);
  ASSERT(others != NULL);

  /* Attack tables */
  pWAttacker[0] =   pWAttacker[1] =   pWAttacker[2] =   pWAttacker[3] = 
    pWAttacker[4] =   pWAttacker[5] =   pWAttacker[6] =   pWAttacker[7] = 0; 
  pBAttacker[0] =   pBAttacker[1] =   pBAttacker[2] =   pBAttacker[3] = 
    pBAttacker[4] =   pBAttacker[5] =   pBAttacker[6] =   pBAttacker[7] = 0; 

  strcpy(pos->opponentName, "opponent");
  pos->iAm = black;
  pos->sNodes = pos->qNodes = 0;

  pos->WPBoard = pos->WNBoard = pos->WBBoard = 
    pos->WRBoard = pos->WQBoard = 0;
  pos->wKSq = 64;
  pos->BPBoard = pos->BNBoard = pos->BBBoard = 
    pos->BRBoard = pos->BQBoard = 0;
  pos->bKSq = 64;
  pos->RotatedBoard90 = pos->RotatedBoard45l = 
    pos->RotatedBoard45r = 0;

  thisPlyData->key = 0;

  pos->wPCount[0] = pos->wPCount[1] = pos->wPCount[2] = 
  pos->wPCount[3] = pos->wPCount[4] = pos->wPCount[5] = 
  pos->wPCount[6] = pos->wPCount[7] = 
  pos->bPCount[0] = pos->bPCount[1] = pos->bPCount[2] = 
  pos->bPCount[3] = pos->bPCount[4] = pos->bPCount[5] = 
  pos->bPCount[6] = pos->bPCount[7] = 0;
  for (sq = A1; sq <= H8; sq++)
    {
      switch (piece[sq])
	{
	case wP:
	  pos->WPBoard |= OneMask[sq];
	  thisPlyData->key ^= others->wPKey[sq];
	  pos->wPCount[column(sq)]++;
	  break;
	case wN:
	  pos->WNBoard |= OneMask[sq];
	  thisPlyData->key ^= others->wNKey[sq];
	  break;
	case wB:
	  pos->WBBoard |= OneMask[sq];
	  thisPlyData->key ^= others->wBKey[sq];
	  break;
	case wR:
	  pos->WRBoard |= OneMask[sq];
	  thisPlyData->key ^= others->wRKey[sq];
	  break;
	case wQ:
	  pos->WQBoard |= OneMask[sq];
	  thisPlyData->key ^= others->wQKey[sq];
	  break;
	case wK:
	  pos->wKSq = sq;
	  thisPlyData->key ^= others->wKKey[sq];
	  break;
	case bP:
	  pos->BPBoard |= OneMask[sq];
	  thisPlyData->key ^= others->bPKey[sq];
	  pos->bPCount[column(sq)]++;
	  break;
	case bN:
	  pos->BNBoard |= OneMask[sq];
	  thisPlyData->key ^= others->bNKey[sq];
	  break;
	case bB:
	  pos->BBBoard |= OneMask[sq];
	  thisPlyData->key ^= others->bBKey[sq];
	  break;
	case bR:
	  pos->BRBoard |= OneMask[sq];
	  thisPlyData->key ^= others->bRKey[sq];
	  break;
	case bQ:
	  pos->BQBoard |= OneMask[sq];
	  thisPlyData->key ^= others->bQKey[sq];
	  break;
	case bK:
	  pos->bKSq = sq;
	  thisPlyData->key ^= others->bKKey[sq];
	  break;
	}

      if (piece[sq] != none)
	{
	  pos->RotatedBoard90 |= OneMask[rotate90[sq]];
	  pos->RotatedBoard45l |= OneMask[rotate45l[sq]];
	  pos->RotatedBoard45r |= OneMask[rotate45r[sq]];
	}
    }

  if (pos->wKSq == 64) 
    {
      printf("ERROR: I can't play chess without White King.\n");
      exit(EXIT_FAILURE);
    }
  if (pos->bKSq == 64) 
    {
      printf("ERROR: I can't play chess without Black King.\n");
      exit(EXIT_FAILURE);
    }

  thisPlyData->key ^= others->wCanCastleKey[thisPlyData->wCanCastle];
  thisPlyData->key ^= others->bCanCastleKey[thisPlyData->bCanCastle];
 
  pos->WBoard = pos->WPBoard | pos->WNBoard | pos->WBBoard | 
                  pos->WRBoard | pos->WQBoard | OneMask[pos->wKSq];
  pos->BBoard = pos->BPBoard | pos->BNBoard | pos->BBBoard | 
                  pos->BRBoard | pos->BQBoard | OneMask[pos->bKSq];
  
  pos->moveNumber = pos->repHead = 0;
  for (sq = 0; sq < maxPly; sq++)
    {
      pos->killerFrom[sq] = pos->killerTo[sq] = 0;
    }
  pos->Flags &= NilMask[1];    /* not forced */
  pos->Flags &= NilMask[2];    /* game has not been listed yet */
  pos->Flags &= NilMask[4];    /* search not terminated */
  pos->Flags |= OneMask[10];   /* timeReserved mode */
  pos->movesPerTC = 40;
  /* default: 5 minutes per game */
  pos->timeLeft0 = pos->timeLeft = pos->oTimeLeft = 30000;
  pos->timeInc = 0;                        /* default: no time increment */
  pos->deltaRating = 0;
  pos->pvExt = pvExt0;
  pos->checkExt = checkExt0;
  pos->onlyReplyExt = onlyReplyExt0;
  pos->mateThreatExt = mateThreatExt0;
  pos->parrotExt = parrotExt0;
  pos->pawn7thExt = pawn7thExt0;
}


/* Initialize the position boards */
void initPosBoard(ui *wToMove, sPos *pos, sPlyData *thisPlyData, 
		  sOthers *others)
{
  ui sq, piece[64];

  ASSERT(*wToMove == false || *wToMove == true);
  ASSERT(pos != NULL);
  ASSERT(thisPlyData != NULL);
  ASSERT(others != NULL);

  piece[A1] = wR;
  piece[B1] = wN;
  piece[C1] = wB;
  piece[D1] = wQ;
  piece[E1] = wK;
  piece[F1] = wB;
  piece[G1] = wN;
  piece[H1] = wR;
  for (sq = A2; sq <=H2; sq++) piece[sq] = wP;
  for (sq = A3; sq <=H6; sq++) piece[sq] = none;
  for (sq = A7; sq <=H7; sq++) piece[sq] = bP;
  piece[A8] = bR;
  piece[B8] = bN;
  piece[C8] = bB;
  piece[D8] = bQ;
  piece[E8] = bK;
  piece[F8] = bB;
  piece[G8] = bN;
  piece[H8] = bR;

#ifdef VERIFY
  for (sq = A1; sq <= H8; sq++) thisPlyData->piece[sq] = piece[sq];
#endif

  thisPlyData->wCanCastle = thisPlyData->bCanCastle = 3;
  thisPlyData->EP = 0;
  *wToMove = true;

  finalizeInit(piece, pos, thisPlyData, others);
}


#ifdef VERIFY
/* Scan the board to check position boards */
BB scanBoard(ui *piece, BB EP, int wCanCastle, int bCanCastle,
	       sPos *pos, sOthers *others)
{
  BB key = 0;
  ui sq;

  ASSERT(pos != NULL);
  ASSERT(others != NULL);

  pos->WPBoard = pos->WNBoard = pos->WBBoard = 
    pos->WRBoard = pos->WQBoard = 0;
  pos->BPBoard = pos->BNBoard = pos->BBBoard = 
    pos->BRBoard = pos->BQBoard = 0;
  pos->RotatedBoard90 = pos->RotatedBoard45l = 
    pos->RotatedBoard45r = 0;

  pos->wPCount[0] = pos->wPCount[1] = pos->wPCount[2] = 
  pos->wPCount[3] = pos->wPCount[4] = pos->wPCount[5] = 
  pos->wPCount[6] = pos->wPCount[7] = 
  pos->bPCount[0] = pos->bPCount[1] = pos->bPCount[2] = 
  pos->bPCount[3] = pos->bPCount[4] = pos->bPCount[5] = 
  pos->bPCount[6] = pos->bPCount[7] = 0;
  for (sq = A1; sq <= H8; sq++)
    {
      switch (piece[sq])
	{
	case wP:
	  pos->WPBoard |= OneMask[sq];
	  key ^= others->wPKey[sq];
	  pos->wPCount[column(sq)]++;
	  break;
	case wN:
	  pos->WNBoard |= OneMask[sq];
	  key ^= others->wNKey[sq];
	  break;
	case wB:
	  pos->WBBoard |= OneMask[sq];
	  key ^= others->wBKey[sq];
	  break;
	case wR:
	  pos->WRBoard |= OneMask[sq];
	  key ^= others->wRKey[sq];
	  break;
	case wQ:
	  pos->WQBoard |= OneMask[sq];
	  key ^= others->wQKey[sq];
	  break;
	case wK:
	  pos->wKSq = sq;
	  key ^= others->wKKey[sq];
	  break;
	case bP:
	  pos->BPBoard |= OneMask[sq];
	  key ^= others->bPKey[sq];
	  pos->bPCount[column(sq)]++;
	  break;
	case bN:
	  pos->BNBoard |= OneMask[sq];
	  key ^= others->bNKey[sq];
	  break;
	case bB:
	  pos->BBBoard |= OneMask[sq];
	  key ^= others->bBKey[sq];
	  break;
	case bR:
	  pos->BRBoard |= OneMask[sq];
	  key ^= others->bRKey[sq];
	  break;
	case bQ:
	  pos->BQBoard |= OneMask[sq];
	  key ^= others->bQKey[sq];
	  break;
	case bK:
	  pos->bKSq = sq;
	  key ^= others->bKKey[sq];
	  break;
	}

      if (piece[sq] != none)
	{
	  pos->RotatedBoard90 |= OneMask[rotate90[sq]];
	  pos->RotatedBoard45l |= OneMask[rotate45l[sq]];
	  pos->RotatedBoard45r |= OneMask[rotate45r[sq]];
	}
    }

  if (EP) key ^= others->ePKey[firstOne(EP)];
 if (wCanCastle != 13)
    {
      if (wCanCastle > 0) 
	key ^= others->wCanCastleKey[wCanCastle];
      else key ^= others->wCanCastleKey[0];
      if (bCanCastle > 0) 
	key ^= others->bCanCastleKey[bCanCastle];
      else key ^= others->bCanCastleKey[0];
    }

  pos->WBoard = pos->WPBoard | pos->WNBoard | pos->WBBoard | 
    pos->WRBoard | pos->WQBoard | OneMask[pos->wKSq];
  pos->BBoard = pos->BPBoard | pos->BNBoard | pos->BBBoard | 
    pos->BRBoard | pos->BQBoard | OneMask[pos->bKSq];

  return key;
}
#endif


/* Read the piece square tables */
void readSqvalue(sOthers *others)
{
  int sq;
  char line[80];
  FILE *fdin;

  ASSERT(others != NULL);

  if ((fdin = fopen("sqvalue", "r")) == NULL)
    {
      printf("Playing without a square value table.\n");
      return;
    }

  /* wP */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wPSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* wN */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wNSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* wB */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wBSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* wR */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wRSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* wQ */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wQSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* wK */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wKSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bP */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bPSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bN */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bNSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bB */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bBSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bR */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bRSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bQ */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bQSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bK */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bKSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* wPassedP */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->wPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  /* bPassedP */
  fgets(line, 80, fdin);
  for(sq = A8; sq <= H8; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A7; sq <= H7; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A6; sq <= H6; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A5; sq <= H5; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A4; sq <= H4; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A3; sq <= H3; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A2; sq <= H2; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  for(sq = A1; sq <= H1; sq++) fscanf(fdin, "%d", &others->bPassedPSqvalue[sq]);
  fgets(line, 80, fdin);
  fgets(line, 80, fdin);

  fclose(fdin);
}


/* Initialize */
void init(ui *wToMove, sPos *pos, sPlyData *plyData, sHash **hash, 
	  sOthers *others)
{
  time_t when;
  struct tm *timeStr;

  ASSERT(*wToMove == false || *wToMove == true);
  ASSERT(pos != NULL);
  ASSERT(plyData != NULL);
  ASSERT(*hash != NULL);
  ASSERT(others != NULL);

  pos->failBook = pos->openingNo = 0;
  pos->posID[0] = pos->solution[0] = pos->myMove[0] = pos->gameID[0] = '\0';
  /* today's date */
  time(&when);
  timeStr = localtime(&when);
  strftime(pos->fullDate, 16, "%m%d%y_%H:%M:%S", timeStr);
  pos->searchDepth = maxPly;

  initFLOne();
  initBitBoards(others);
  initRankAttacks();
  initKeys(others);
  clearHash(hash, pos);
  initPosBoard(wToMove, pos, &plyData[0], others);
  readSqvalue(others);
  setRandomSeed((unsigned int) time ((time_t *) 0));
  pos->Flags |= OneMask[3];    /* randomize by default */
  pos->rOpening = 1 + random32() % 3;  /* choose an all purpose opening */
}
